/*
 * Buffer.h
 *
 *  Created on: Apr 1, 2011
 *      Author: lipari
 */

#ifndef BUFFER_H_
#define BUFFER_H_

#include <vector>

class OutputInterface;
class Block;

class Buffer {
	std::vector<double> array;
	Block &out;
public:
	explicit Buffer(unsigned n, Block &o);
	Buffer(const Buffer &b) : array(b.array), out(b.out) {}

	void write(unsigned i, double value);
	double read(unsigned i);
	Block &getBlock() { return out; }
};

class InputPort {
	Buffer *buffer;
	unsigned index;
public:
	InputPort();
	double read();
	void connect(Buffer &b, unsigned i);
	Block *getPreviousBlock();
};

/*class InputInterface {
protected:
	std::vector<InputPort> in;
public:
	InputInterface(unsigned n) : in(n) {}
	/// todo: add error checking
	InputPort &getInputPort(unsigned i) { return in[i]; }

	std::vector<Block *> intPreviousBlocks();
};

class OutputInterface {
protected:
	Buffer output;
public:
	OutputInterface(unsigned n) : output(n, *this) {}
	Buffer& getOutputBuffer() { return output; }
};*/

#endif /* BUFFER_H_ */
