//============================================================================
// Name        : DiscreteSim.cpp
// Author      : G Lipari
// Version     :
// Copyright   : OOSD
// Description : Hello World in C++, Ansi-style
//============================================================================

#include <iostream>
#include <vector>
using namespace std;

#include "Ramp.h"
#include "Multiplication.h"
#include "PrintSink.h"
#include "GlobalTime.h"

void connectBlocks(Block *b1, unsigned out, Block *b2, unsigned in)
{
	b2->getInputPort(in).connect(b1->getOutputBuffer(), out);
}

void prepare_blocks(vector<Block*> & blocks)
{
    Ramp *r = new Ramp(0.5);

    Multiplication *m = new Multiplication(2);
    PrintSink *ps = new PrintSink();
    blocks.push_back(r);
    blocks.push_back(m);
    blocks.push_back(ps);

    connectBlocks(r, 0, m, 0);
    connectBlocks(m, 0, ps, 0);

    //m->getInputPort().connect(r->getOutputBuffer(), 0);
    //ps->getInputPort().connect(m->getOutputBuffer(), 0);
}


int main() {
	cout << " --------- *** Discrete Simulation *** -------------" << endl;
    vector<Block*> blocks;

    prepare_blocks(blocks);

//    Block *pb2 = blocks[1]->clone();


	for (int i=0; i<10; i++) {
		for (int j=0; j<blocks.size(); ++j)
			blocks[j]->computeOutput();

		GTIME.advance();
	}

	// deletion
	for (int i=0; i<blocks.size(); i++)
		delete blocks[i];

	return 0;
}
